﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel.Description;
using System.ServiceModel.Channels;
using System.ServiceModel.Dispatcher;

namespace GestioService
{
    /// <summary>
    /// Aquest classe intercepta les comunicacions SOAP abans que s'executin
    /// Comprova que l'usuari i passwords inscrits a la capcelera SOAP siguin correctes
    /// Un cop comprovat, permet l'execució de l'ordre
    /// </summary>
    /// <param name="config"></param>
    [AttributeUsage(AttributeTargets.Method)]
    class SecurityOperationBehavior : Attribute, IOperationBehavior
    {
        public void ApplyDispatchBehavior(OperationDescription operationDescription, DispatchOperation dispatchOperation)
        {
            dispatchOperation.Invoker = new SecurityOperationInvoker(dispatchOperation.Invoker);
        }

        #region IOperationBehavior Members

        public void AddBindingParameters(OperationDescription operationDescription, BindingParameterCollection bindingParameters)
        {

        }

        public void ApplyClientBehavior(OperationDescription operationDescription, ClientOperation clientOperation)
        {

        }

        public void Validate(OperationDescription operationDescription)
        {

        }

        #endregion
    }
}
