﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Objects.DataClasses;
using XiquiparcsReunits_DAO;

namespace XiquiparcsReunits_DAO
// namespace XiquiparcsReunits
{
    /**
     * Classe que expandeix els métodes de la classe EntityModel afegint funcions de afegir, modificar i esborrar, i les propietats de 
     * Usuari que crea i modifica i Data de creació i modificació
     * 
     **/
    public static class EntityModelExtension
    {
        /**
         * Funció que permet inserir un registre a la base de dades. Es confirma l'acció directament.
         * 
         **/
        public static void Insertar(this EntityObject aObject)
        {
            ContextDAO.ContextDades.AddObject(aObject.GetType().Name, aObject);
            ContextDAO.Registrar();
        }

        /**
         * Funció que permet esborrar un registre de la base de dades. Es confirma l'acció directament.
         * 
         **/
        public static void Borrar(this EntityObject aObject)
        {
            ContextDAO.ContextDades.DeleteObject(aObject);
            ContextDAO.Registrar();
        }

       
        /**
         * Funció que permet actualitzar la BBDD del context a partir del context. 
         * 
         **/
        public static void Refrescar(this EntityObject aObject)
        {
            ContextDAO.ContextDades.Refresh(System.Data.Objects.RefreshMode.StoreWins, aObject);
            ContextDAO.Registrar();
        }

    }
}
