﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Objects.DataClasses;

namespace XiquiparcsReunits_DAO
{
    /// <summary>
    /// Objecte que integra totes les dades generals de la empresa: dades fiscals, postals, Internet...
    /// </summary>
    public partial class Empresa : EntityObject
    {
        /// <summary>
        /// Obté un objecte concret a partir del seu identificador
        /// </summary>
        /// <param name="id">Identificador de l'objecte</param>
        /// <returns>Objecte buscat</returns>
        public static Empresa GetInstancia()
        {
            return (from oEmpresa in ContextDAO.ContextDades.Empresa
                    select oEmpresa).FirstOrDefault();
        }

        /// <summary>
        /// Constructor amb tots els paràmetres inicialitzats
        /// </summary>
        /// <param name="nif">NIF de l'empresa</param>
        /// <param name="nom_fiscal">Nom fiscal de l'empresa</param>
        /// <param name="nom_comercial">Nom comercial de l'empresa</param>
        /// <param name="telefon1">Telèfon principal de l'empresa</param>
        /// <param name="correu_electronic">Correu electrònic principal de l'empresa</param>
        /// <param name="direccio_web">Direcció web de l'empresa</param>
        /// <param name="direccio_empresa">Direcció postal de l'empresa</param>
        /// <param name="codpos_empresa">Codi postal de l'empresa</param>
        /// <param name="poblacio">Població de l'empresa</param>
        /// <param name="provincia">Província de l'empresa</param>
        /// <param name="estat">Estat de l'empresa</param>
        /// <param name="usuari_crea_empresa">Usuari que crea l'empresa</param>
        /// <returns>Objecte creat</returns>
        public static Empresa CreateEmpresa(String nif, String nom_fiscal, String nom_comercial, String telefon1, String correu_electronic, String direccio_web, String direccio_empresa, Int32 codpos_empresa, String poblacio, String provincia, String estat, String usuari_crea_empresa)
        {
            Empresa empresa = new Empresa();
            empresa.NIF = nif;
            empresa.nom_fiscal = nom_fiscal;
            empresa.nom_comercial = nom_comercial;
            empresa.telefon1 = telefon1;
            empresa.correu_electronic = correu_electronic;
            empresa.direccio_web = direccio_web;
            empresa.direccio_empresa = direccio_empresa;
            empresa.codpos_empresa = codpos_empresa;
            empresa.poblacio = poblacio;
            empresa.provincia = provincia;
            empresa.estat = estat;
            empresa.usuari_crea_empresa = usuari_crea_empresa;
            empresa.usuari_mod_empresa = usuari_crea_empresa;
            empresa.data_crea_empresa = DateTime.Now;
            empresa.data_mod_empresa = DateTime.Now;
            return empresa;
        }
    }
}
