﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Data.Objects.DataClasses;

namespace XiquiparcsReunits_DAO
{

    public partial class Pagina : EntityObject
    {
        /// <summary>
        /// Obté un llistat de les Pagines del sistema
        /// </summary>
        /// <returns>Llistat amb les Pagines del sistema</returns>
        public static List<Pagina> GetInstancies()
        { 
            List<Pagina> pagines = null;
            pagines = (from oPagina in ContextDAO.ContextDades.Pagina select oPagina).ToList();
            return pagines;
        }
        
        /// <summary>
        /// Obté un Pagina a partir de la seva posició
        /// </summary>
        /// <param name="id">Identificador de la Pagina</param>
        /// <returns>Pagina buscada</returns>
        public static Pagina GetInstancia(int posicio)
        {
            Pagina pagina = null;
            
                    pagina= (from oPagina in ContextDAO.ContextDades.Pagina
                    where oPagina.id_pagina == posicio
                    select oPagina).FirstOrDefault();
              
            return pagina;
        }

        /// <summary>
        /// Obté un llistat de les posicions de les pagines del sistema
        /// </summary>
        /// <returns>Llistat de les posicions de les pagines del sistema</returns>
        public static List<String> GetNomInstancies()
        {
            return (from oPagina in ContextDAO.ContextDades.Pagina
                    select oPagina.id_pagina.ToString()).ToList();
        }


        /// <summary>
        /// Crea una nova Pagina que s'afegirà darrera al llistat de pàgines
        /// </summary>
        /// <param name="titol">Titol del Pagina</param>
        /// <param name="text_menu">Text al menú de la pàgina</param>
        /// <param name="observacions">Observacions sobre la pàgina</param>
        /// <param name="usuari_crea">Usuari que crea la pàgina</param>
        /// <returns>Nova Pagina creada</returns>
        public static Pagina CreatePagina(string titol, string text_menu, string observacions, string usuari_crea)
        {
            Pagina Pagina = new Pagina();
            List<Pagina> pagines = Pagina.GetInstancies();
            if (pagines.Count>0)
                Pagina.id_pagina = pagines.Max(m => m.id_pagina) + 1;
            else Pagina.id_pagina = 1;
            Pagina.nom_pagina = titol;
            Pagina.text_menu = text_menu;
            Pagina.observacions = observacions;
            Pagina.usuari_crea_pagina = usuari_crea;
            Pagina.usuari_mod_pagina = usuari_crea;
            Pagina.data_crea_pagina = DateTime.Now;
            Pagina.data_mod_pagina = DateTime.Now;
            return Pagina;
        }
    }
}
