﻿using System;
using System.ComponentModel;
using System.Collections.ObjectModel;
//using XiquiparcsReunits_DAO;
using XiquiparcsReunits_RDA.Tools;
using System.ServiceModel;
using System.ServiceModel.Channels;


namespace XiquiparcsReunits_RDA.Model
{
	public class Rol: INotifyPropertyChanged
	{
		public string Nom_rol {get;set;}
		public bool Acces_escriptori{get;set;}
		public bool Modifica_empresa{get;set;}
		public Dret Usuari {get;set;}
		public Dret Modifica_Rol {get;set;}
		public Dret Reserva {get;set;}
        public Dret Reserva_forana { get; set; }
        public Dret Recurs { get; set; }
        public Dret Seccio { get; set; }
        public Dret Oferta { get; set; }
        public Dret Factura { get; set; }
        public Dret Factura_forana { get; set; }
        public Dret Cobrament { get; set; }
		public Dret Tipus_IVA {get;set;}
        public Dret Pagina { get; set; }
        public Dret Continent { get; set; }
        public Dret Contingut { get; set; }
        			
		public event PropertyChangedEventHandler PropertyChanged;
		
		public void OnPropertyChanged(string name){
			if (PropertyChanged !=null)
					PropertyChanged(this, new PropertyChangedEventArgs(name));
		}
		
		public static ObservableCollection<Rol> GetInstancies(){
            ObservableCollection<Rol> list = new ObservableCollection<Rol>();
            GestorXiquiparc.GestorXiquiparcClient client = new GestorXiquiparc.GestorXiquiparcClient();
            OperationContextScope scope = new OperationContextScope((IContextChannel)client.InnerChannel);
            MessageHeaders messageHeadersElement = OperationContext.Current.OutgoingMessageHeaders;

            messageHeadersElement.Add(MessageHeader.CreateHeader("username", "", SingletonLoggedUser.Instance.LoggedUser.Id_usuari));
            messageHeadersElement.Add(MessageHeader.CreateHeader("password", "", SingletonLoggedUser.Instance.LoggedUser.Pwd));

            foreach (GestorXiquiparc.Rol it in client.GetRols())
            {
                list.Add(Rol.CreateRol(it.nom_rol, it.modifica_empresa, it.usuari, it.reserva_forana, it.reserva, it.recurs, it.seccio, it.oferta, it.factura, it.factura_forana, it.cobrament, it.tipus_IVA, it.pagina, it.continent, it.contingut, it.acces_escriptori, it.rol1));
            }
            return list;
        }

        public static ObservableCollection<string> GetNomInstancies()
        {
            GestorXiquiparc.GestorXiquiparcClient client = new GestorXiquiparc.GestorXiquiparcClient();
            OperationContextScope scope = new OperationContextScope((IContextChannel)client.InnerChannel);
            MessageHeaders messageHeadersElement = OperationContext.Current.OutgoingMessageHeaders;

            messageHeadersElement.Add(MessageHeader.CreateHeader("username", "", SingletonLoggedUser.Instance.LoggedUser.Id_usuari));
            messageHeadersElement.Add(MessageHeader.CreateHeader("password", "", SingletonLoggedUser.Instance.LoggedUser.Pwd));

            return new ObservableCollection<string>(client.GetNomRols());
        }

        public static Rol GetInstancia(string id)
        {
            GestorXiquiparc.GestorXiquiparcClient client = new GestorXiquiparc.GestorXiquiparcClient();
            OperationContextScope scope = new OperationContextScope((IContextChannel)client.InnerChannel);
            MessageHeaders messageHeadersElement = OperationContext.Current.OutgoingMessageHeaders;

            messageHeadersElement.Add(MessageHeader.CreateHeader("username", "", SingletonLoggedUser.Instance.LoggedUser.Id_usuari));
            messageHeadersElement.Add(MessageHeader.CreateHeader("password", "", SingletonLoggedUser.Instance.LoggedUser.Pwd));

            GestorXiquiparc.Rol it = client.GetRol(id);
            return Rol.CreateRol(it.nom_rol, it.modifica_empresa, it.usuari, it.reserva_forana, it.reserva, it.recurs, it.seccio, it.oferta, it.factura, it.factura_forana, it.cobrament, it.tipus_IVA, it.pagina, it.continent, it.contingut, it.acces_escriptori, it.rol1);
        }

		 public static Rol CreateRol(String nom_rol, Boolean modifica_empresa, String usuari, String reserva_forana, String reserva, String recurs, String seccio, String oferta, String factura, String factura_forana, String cobrament, String tipus_IVA, String pagina, String continent, String contingut, Boolean acces_escriptori, String rol)
        {
            Rol resultat = new Rol();
            resultat.Nom_rol = nom_rol;
            resultat.Modifica_empresa = modifica_empresa;
            resultat.Usuari = new Dret(usuari);
            resultat.Reserva_forana = new Dret(reserva_forana);
            resultat.Reserva = new Dret(reserva);
            resultat.Recurs = new Dret(recurs);
            resultat.Seccio = new Dret(seccio);
            resultat.Oferta = new Dret(oferta);
            resultat.Factura = new Dret(factura);
            resultat.Factura_forana = new Dret(factura_forana);
            resultat.Cobrament = new Dret(cobrament);
            resultat.Tipus_IVA = new Dret(tipus_IVA);
            resultat.Pagina = new Dret(pagina);
            resultat.Continent = new Dret(continent);
            resultat.Contingut = new Dret(contingut);
            resultat.Acces_escriptori = acces_escriptori;
            resultat.Modifica_Rol = new Dret(rol);
            return resultat;
        }

		public static void Insert(Rol rol){
            GestorXiquiparc.GestorXiquiparcClient client = new GestorXiquiparc.GestorXiquiparcClient();
            OperationContextScope scope = new OperationContextScope((IContextChannel)client.InnerChannel);
            MessageHeaders messageHeadersElement = OperationContext.Current.OutgoingMessageHeaders;

            messageHeadersElement.Add(MessageHeader.CreateHeader("username", "", SingletonLoggedUser.Instance.LoggedUser.Id_usuari));
            messageHeadersElement.Add(MessageHeader.CreateHeader("password", "", SingletonLoggedUser.Instance.LoggedUser.Pwd));

            client.CreateRol(rol.Nom_rol, rol.Acces_escriptori, rol.Modifica_empresa, rol.Modifica_Rol.ToString(), rol.Usuari.ToString(), rol.Reserva_forana.ToString(), rol.Reserva.ToString(), rol.Recurs.ToString(), rol.Seccio.ToString(), rol.Oferta.ToString(), rol.Factura.ToString(), rol.Factura_forana.ToString(), rol.Cobrament.ToString(), rol.Tipus_IVA.ToString(), rol.Pagina.ToString(), rol.Continent.ToString(), rol.Contingut.ToString(), SingletonLoggedUser.Instance.LoggedUser.Id_usuari);
        }

        public static void Update(Rol rol)
        {
            GestorXiquiparc.GestorXiquiparcClient client = new GestorXiquiparc.GestorXiquiparcClient();
            OperationContextScope scope = new OperationContextScope((IContextChannel)client.InnerChannel);
            MessageHeaders messageHeadersElement = OperationContext.Current.OutgoingMessageHeaders;

            messageHeadersElement.Add(MessageHeader.CreateHeader("username", "", SingletonLoggedUser.Instance.LoggedUser.Id_usuari));
            messageHeadersElement.Add(MessageHeader.CreateHeader("password", "", SingletonLoggedUser.Instance.LoggedUser.Pwd));

            client.UpdateRol(rol.Nom_rol, rol.Acces_escriptori, rol.Modifica_empresa, rol.Modifica_Rol.ToString(), rol.Usuari.ToString(), rol.Reserva_forana.ToString(), rol.Reserva.ToString(), rol.Recurs.ToString(), rol.Seccio.ToString(), rol.Oferta.ToString(), rol.Factura.ToString(), rol.Factura_forana.ToString(), rol.Cobrament.ToString(), rol.Tipus_IVA.ToString(), rol.Pagina.ToString(), rol.Continent.ToString(), rol.Contingut.ToString(), SingletonLoggedUser.Instance.LoggedUser.Id_usuari);
        }

        public static void Remove(string nom_rol)
        {
            GestorXiquiparc.GestorXiquiparcClient client = new GestorXiquiparc.GestorXiquiparcClient();
            OperationContextScope scope = new OperationContextScope((IContextChannel)client.InnerChannel);
            MessageHeaders messageHeadersElement = OperationContext.Current.OutgoingMessageHeaders;

            messageHeadersElement.Add(MessageHeader.CreateHeader("username", "", SingletonLoggedUser.Instance.LoggedUser.Id_usuari));
            messageHeadersElement.Add(MessageHeader.CreateHeader("password", "", SingletonLoggedUser.Instance.LoggedUser.Pwd));

            client.DeleteRol(nom_rol, SingletonLoggedUser.Instance.LoggedUser.Id_usuari);
		}
		
		
		public  override string ToString(){
			return this.Nom_rol;
		}
		
	}
}