﻿using System;
using System.ComponentModel;
using System.Collections.ObjectModel;
//using XiquiparcsReunits_DAO;
using XiquiparcsReunits_RDA.Tools;
using System.ServiceModel;
using System.ServiceModel.Channels;


namespace XiquiparcsReunits_RDA.Model
{
	public class Seccio: INotifyPropertyChanged
	{
		public string Id_seccio {get;set;}
        public string Descripcio { get; set; }
        			
		public event PropertyChangedEventHandler PropertyChanged;
		
		public void OnPropertyChanged(string name){
			if (PropertyChanged !=null)
					PropertyChanged(this, new PropertyChangedEventArgs(name));
		}

		private static ObservableCollection<Seccio>  initInstancies(){
			ObservableCollection<Seccio> list=new ObservableCollection<Seccio>();
            GestorXiquiparc.GestorXiquiparcClient client = new GestorXiquiparc.GestorXiquiparcClient();
            OperationContextScope scope = new OperationContextScope((IContextChannel)client.InnerChannel);
            MessageHeaders messageHeadersElement = OperationContext.Current.OutgoingMessageHeaders;

            messageHeadersElement.Add(MessageHeader.CreateHeader("username", "", SingletonLoggedUser.Instance.LoggedUser.Id_usuari));
            messageHeadersElement.Add(MessageHeader.CreateHeader("password", "", SingletonLoggedUser.Instance.LoggedUser.Pwd));

            foreach (GestorXiquiparc.Seccio it in client.GetSeccions())
            {
                list.Add(Seccio.CreateSeccio(it.id_seccio, it.descripcio_seccio));
            }
			return list;	
		}
		
		public static ObservableCollection<Seccio> GetInstancies(){
			return initInstancies();
		}
		
		public static Seccio GetInstancia(string id)
        {
            GestorXiquiparc.GestorXiquiparcClient client = new GestorXiquiparc.GestorXiquiparcClient();
            OperationContextScope scope = new OperationContextScope((IContextChannel)client.InnerChannel);
            MessageHeaders messageHeadersElement = OperationContext.Current.OutgoingMessageHeaders;

            messageHeadersElement.Add(MessageHeader.CreateHeader("username", "", SingletonLoggedUser.Instance.LoggedUser.Id_usuari));
            messageHeadersElement.Add(MessageHeader.CreateHeader("password", "", SingletonLoggedUser.Instance.LoggedUser.Pwd));

            GestorXiquiparc.Seccio it = client.GetSeccio(id);
            return Seccio.CreateSeccio(it.id_seccio, it.descripcio_seccio);
        }


        public static ObservableCollection<string> GetNomInstancies()
        {
            GestorXiquiparc.GestorXiquiparcClient client = new GestorXiquiparc.GestorXiquiparcClient();
            OperationContextScope scope = new OperationContextScope((IContextChannel)client.InnerChannel);
            MessageHeaders messageHeadersElement = OperationContext.Current.OutgoingMessageHeaders;

            messageHeadersElement.Add(MessageHeader.CreateHeader("username", "", SingletonLoggedUser.Instance.LoggedUser.Id_usuari));
            messageHeadersElement.Add(MessageHeader.CreateHeader("password", "", SingletonLoggedUser.Instance.LoggedUser.Pwd));

            return new ObservableCollection<string>(client.GetNomSeccions());
        }
		
		
	 public static Seccio CreateSeccio(String id_seccio, String descripcio)
        {
            Seccio seccio = new Seccio();
            seccio.Id_seccio = id_seccio;
            seccio.Descripcio = descripcio;
            return seccio;
        }

     public static void Update(Seccio seccio)
     {
         GestorXiquiparc.GestorXiquiparcClient client = new GestorXiquiparc.GestorXiquiparcClient();
         OperationContextScope scope = new OperationContextScope((IContextChannel)client.InnerChannel);
         MessageHeaders messageHeadersElement = OperationContext.Current.OutgoingMessageHeaders;

         messageHeadersElement.Add(MessageHeader.CreateHeader("username", "", SingletonLoggedUser.Instance.LoggedUser.Id_usuari));
         messageHeadersElement.Add(MessageHeader.CreateHeader("password", "", SingletonLoggedUser.Instance.LoggedUser.Pwd));

         client.UpdateSeccio(seccio.Id_seccio, seccio.Descripcio, SingletonLoggedUser.Instance.LoggedUser.Id_usuari);
     }

		public static void Insert(Seccio seccio){
            GestorXiquiparc.GestorXiquiparcClient client = new GestorXiquiparc.GestorXiquiparcClient();
            OperationContextScope scope = new OperationContextScope((IContextChannel)client.InnerChannel);
            MessageHeaders messageHeadersElement = OperationContext.Current.OutgoingMessageHeaders;

            messageHeadersElement.Add(MessageHeader.CreateHeader("username", "", SingletonLoggedUser.Instance.LoggedUser.Id_usuari));
            messageHeadersElement.Add(MessageHeader.CreateHeader("password", "", SingletonLoggedUser.Instance.LoggedUser.Pwd));

            client.CreateSeccio(seccio.Id_seccio, seccio.Descripcio, SingletonLoggedUser.Instance.LoggedUser.Id_usuari);
		}
		
		public static void Remove(string id_seccio){
            GestorXiquiparc.GestorXiquiparcClient client = new GestorXiquiparc.GestorXiquiparcClient();
            OperationContextScope scope = new OperationContextScope((IContextChannel)client.InnerChannel);
            MessageHeaders messageHeadersElement = OperationContext.Current.OutgoingMessageHeaders;

            messageHeadersElement.Add(MessageHeader.CreateHeader("username", "", SingletonLoggedUser.Instance.LoggedUser.Id_usuari));
            messageHeadersElement.Add(MessageHeader.CreateHeader("password", "", SingletonLoggedUser.Instance.LoggedUser.Pwd));

            client.DeleteSeccio(id_seccio, SingletonLoggedUser.Instance.LoggedUser.Id_usuari);
		}

		public  override string ToString(){
			return this.Id_seccio;
		}
	}
}