﻿using XiquiparcsReunits_RDA.ViewModels;
using Microsoft.Practices.Prism.Events;
using Microsoft.Practices.Unity;
using System.Windows;

namespace XiquiparcsReunits_RDA.Tools
{
	public class Locator
	{
			public IUnityContainer Container { get; set; }

           	public Locator(){

				Container = new UnityContainer();
                Container.RegisterType<PrincipalViewModel>(new ContainerControlledLifetimeManager());
                Container.RegisterType<GestionarEmpresaViewModel>(new ContainerControlledLifetimeManager());
                Container.RegisterType<GestionarCobramentsViewModel>(new ContainerControlledLifetimeManager());
                Container.RegisterType<GestionarFacturesViewModel>(new ContainerControlledLifetimeManager());
                Container.RegisterType<GestionarOfertesViewModel>(new ContainerControlledLifetimeManager());
                Container.RegisterType<GestionarRecursosViewModel>(new ContainerControlledLifetimeManager());
                Container.RegisterType<GestionarRolsViewModel>(new ContainerControlledLifetimeManager());
                Container.RegisterType<GestionarSeccionsViewModel>(new ContainerControlledLifetimeManager());
                Container.RegisterType<GestionarTipusIVAViewModel>(new ContainerControlledLifetimeManager());
                Container.RegisterType<GestionarUsuarisViewModel>(new ContainerControlledLifetimeManager());
                Container.RegisterType<IEventAggregator, EventAggregator>(new ContainerControlledLifetimeManager());
			}
        
			public PrincipalViewModel PrincipalViewModel {

                get
                {
                    return Container.Resolve<PrincipalViewModel>();
                }
			}

            public GestionarEmpresaViewModel GestionarEmpresaViewModel
            {

                get
                {
                    return Container.Resolve<GestionarEmpresaViewModel>();
                }
            }

			public GestionarCobramentsViewModel GestionarCobramentsViewModel { 
              
				get{ 
                    return Container.Resolve<GestionarCobramentsViewModel>();
                }
			}
			
			public GestionarFacturesViewModel GestionarFacturesViewModel {
				get{ return Container.Resolve<GestionarFacturesViewModel>();}
			}
			
			public GestionarOfertesViewModel GestionarOfertesViewModel {
				get{ return Container.Resolve<GestionarOfertesViewModel>();}
			}
						
			public GestionarRecursosViewModel GestionarRecursosViewModel {
				get{ return Container.Resolve<GestionarRecursosViewModel>();}
			}
			
			public GestionarRolsViewModel GestionarRolsViewModel {
				get{ return Container.Resolve<GestionarRolsViewModel>();}
			}
			
			public GestionarSeccionsViewModel GestionarSeccionsViewModel{
				get{ return Container.Resolve<GestionarSeccionsViewModel>();}
			}
			
			public GestionarTipusIVAViewModel GestionarTipusIVAViewModel
				{
				get { 
					return Container.Resolve<GestionarTipusIVAViewModel>();
				}
				}
				
			public GestionarUsuarisViewModel GestionarUsuarisViewModel{
				get{ return Container.Resolve<GestionarUsuarisViewModel>();}
			}
			
			public IEventAggregator MessageBus{
				get { return Container.Resolve<IEventAggregator>();}
			}
	}
}
