﻿using System;
using System.Windows.Data;
using System.Globalization;

namespace XiquiparcsReunits_RDA.Tools
{
    /// <summary>
    /// Classe que converteix un TimeSpan en DateTime mantenint el dia, mes i any
    /// </summary>
    public class TimeConverter : IValueConverter
    {
        private DateTime _original;

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            TimeSpan time =  (TimeSpan)value;
            _original = new DateTime(_original.Year, _original.Month, _original.Day, time.Hours, time.Minutes, time.Seconds);
            return _original;
        }

        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            _original = (DateTime)value;
            return new TimeSpan(_original.Hour, _original.Minute, _original.Second);
        }
    }
}
