﻿using System.ComponentModel;
using XiquiparcsReunits_Silverlight.Tools;
using System;
using XiquiparcsReunits_Silverlight.GestorXiquiparc;

namespace XiquiparcsReunits_Silverlight.Model
{
    /// <summary>
    /// Objecte que integra totes les dades generals de la empresa: dades fiscals, postals, Internet...
    /// </summary>
	public class Empresa: INotifyPropertyChanged
	{
        private string nif;
        public String NIF { get { return nif; } set { nif = value; OnPropertyChanged("NIF"); } }

        private string nom_fiscal;
        public String Nom_fiscal { get { return nom_fiscal; } set { nom_fiscal = value; OnPropertyChanged("Nom_fiscal"); } }

        private string nom_comercial;
        public String Nom_comercial { get { return nom_comercial; } set { nom_comercial = value; OnPropertyChanged("Nom_comercial"); } }

        private string telefon1;
        public String Telefon1 { get { return telefon1; } set { telefon1 = value; OnPropertyChanged("Telefon1"); } }
        
        private string telefon2;
        public string Telefon2 { get { return telefon2; } set { telefon2 = value; OnPropertyChanged("Telefon2"); } }

        private string telefon3;
        public string Telefon3 { get { return telefon3; } set { telefon3 = value; OnPropertyChanged("Telefon3"); } }

        private string fax;
        public string Fax { get { return fax; } set { fax = value; OnPropertyChanged("Fax"); } }

        private string correu_electronic;
        public String Correu_electronic { get { return correu_electronic; } set { correu_electronic = value; OnPropertyChanged("Correu_electronic"); } }
        
        private string direccio_web;
        public String Direccio_web { get { return direccio_web; } set { direccio_web = value; OnPropertyChanged("Direccio_web"); } }
		

        private string direccio_empresa;
        public String Direccio_empresa { get { return direccio_empresa; } set { direccio_empresa = value; OnPropertyChanged("Direccio_empresa"); } }

        private int codpos;
        public Int32 Codpos_empresa { get { return codpos; } set { codpos = value; OnPropertyChanged("Codpos_empresa"); } }

        private string poblacio;
        public String Poblacio { get { return poblacio; } set { poblacio = value; OnPropertyChanged("Poblacio"); } }

        private string provincia;
        public String Provincia { get { return provincia; } set { provincia = value; OnPropertyChanged("Provincia"); } }

        private string dades_mercantils;
        public string Dades_mercantils { get { return dades_mercantils; } set { dades_mercantils = value; OnPropertyChanged("Dades_mercantils"); } }

        private string comentaris;
        public string Comentaris { get { return comentaris; } set { comentaris = value; OnPropertyChanged("Comentaris"); } }

        private string altra_informacio;
        public string Altra_informacio { get { return altra_informacio; } set { altra_informacio = value; OnPropertyChanged("Altra_informacio"); } }

        private string nom_gerent;
        public string Nom_gerent { get { return nom_gerent; } set { nom_gerent = value; OnPropertyChanged("Nom_gerent"); } }

        private string estat;
        public String Estat { get { return estat; } set { estat = value; OnPropertyChanged("Estat"); } }
		
		public event PropertyChangedEventHandler PropertyChanged;
		
		public void OnPropertyChanged(string name){
			if (PropertyChanged !=null)
					PropertyChanged(this, new PropertyChangedEventArgs(name));
		}

        public Empresa()
        {
                      
        }

       
        /// <summary>
        /// Funció que retorna un nou objecte amb tots els paràmetres
        /// </summary>
        /// <param name="nIF">Nou NIF de l'empresa</param>
        /// <param name="nom_fiscal">Nou nom fiscal de l'empresa</param>
        /// <param name="nom_comercial">Nou nom comercial de l'empresa</param>
        /// <param name="telefon1">Nou telèfon 1</param>
        /// <param name="telefon2">Nou telèfon 2</param>
        /// <param name="telefon3">Nou telèfon 3</param>
        /// <param name="fax">Nou fax</param>
        /// <param name="correu_electronic">Nou correu electrònic</param>
        /// <param name="direccio_web">Nova direcció web</param>
        /// <param name="direccio_empresa">Direcció postal de l'empresa</param>
        /// <param name="codpos_empresa">Codi postal de l'empresa</param>
        /// <param name="poblacio">Població postal de l'empresa</param>
        /// <param name="provincia">Provincia postal de l'empresa</param>
        /// <param name="nom_gerent">Nom del gerent o representant de l'empresa</param>
        /// <param name="comentaris">Comentaris sobre l'empresa</param>
        /// <param name="altra_info">Altra informació de l'empresa</param>
        /// <param name="dades_mercantils">Dades mercantils de l'empresa</param>
        /// <param name="estat">Estat (pais) de l'empresa</param>
        /// <returns>Objecte creat a partir dels paràmetres</returns>
		public static Empresa CreateEmpresa(String nIF, String nom_fiscal, String nom_comercial, String telefon1, string telefon2, string telefon3, string fax, String correu_electronic, String direccio_web, String direccio_empresa, Int32 codpos_empresa, String poblacio, String provincia, string nom_gerent, string comentaris, string altra_info, string dades_mercantils, String estat)
        {
            Empresa empresa = new Empresa();
            empresa.NIF = nIF;
            empresa.Nom_fiscal = nom_fiscal;
            empresa.Nom_comercial = nom_comercial;
            empresa.Telefon1 = telefon1;
            empresa.Telefon2 = telefon2;
            empresa.Telefon3 = telefon3;
            empresa.Fax = fax;
            empresa.Correu_electronic = correu_electronic;
            empresa.Direccio_web = direccio_web;
            empresa.Direccio_empresa = direccio_empresa;
            empresa.Codpos_empresa = codpos_empresa;
            empresa.Poblacio = poblacio;
            empresa.Provincia = provincia;
            empresa.Dades_mercantils = dades_mercantils;
            empresa.Comentaris = comentaris;
            empresa.Nom_gerent = nom_gerent;
            empresa.Altra_informacio = altra_info;
            empresa.Estat = estat;
            return empresa;
        }

    
		public override  string ToString(){
			return this.Nom_comercial;
		}
	}
	
}