﻿using System;
using System.ComponentModel;
using System.Collections.ObjectModel;
using XiquiparcsReunits_Silverlight.Tools;
using System.Windows;
using XiquiparcsReunits_Silverlight.GestorXiquiparc;
using System.ServiceModel;
using Microsoft.Practices.Prism.Events;

namespace XiquiparcsReunits_Silverlight.Model
{
    /// <summary>
    /// Objecte que representa un bé o servei que un client pot contractar o consumir
    /// </summary>
    public class Recurs : INotifyPropertyChanged
    {


        private string id_recurs;
        public string Id_recurs { get { return id_recurs; } set { id_recurs = value; OnPropertyChanged("Id_recurs"); } }

        private string id_seccio;
        public string Id_seccio { get { return id_seccio; } set { id_seccio = value; OnPropertyChanged("Id_seccio"); } }

        private Decimal preu;
        public Decimal Preu { get { return preu; } set { preu = value; OnPropertyChanged("Preu"); } }

        private string IVA { get; set; }
        public string Nom_IVA
        {
            get { return IVA; }
            set { IVA = (value); OnPropertyChanged("Nom_IVA"); OnPropertyChanged("Percentatge_IVA"); }
        }

        private int quantitat;
        public int Quantitat { get { return quantitat; } set { quantitat = value; OnPropertyChanged("Quantitat"); } }

        private string descripcio;
        public string Descripcio { get { return descripcio; } set { descripcio = value; OnPropertyChanged("Descripcio"); } }

        private bool disponibilitat_controlable=false;
        public bool Disponibilitat_controlable { get { return disponibilitat_controlable; } set { disponibilitat_controlable = value; OnPropertyChanged("Disponibilitat_controlable"); } }

        private decimal percentatge_IVA;
        public Decimal Percentatge_IVA { get { return percentatge_IVA; } set { percentatge_IVA = value; OnPropertyChanged("Percentatge_IVA"); } }

        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }

       
        /// <summary>
        /// Funció que crea un nou recurs a partir de tots els paràmetres
        /// </summary>
        /// <param name="id_recurs">Identificador del recurs</param>
        /// <param name="id_seccio">Identificador de la secció</param>
        /// <param name="preu">Preu actual del recurs</param>
        /// <param name="nom_IVA">Nom de l'IVA actual a aplicar</param>
        /// <param name="quantitat">Quantitat de recurs total</param>
        /// <param name="disponibilitat_controlable">Booleà que mostra si es controlable la disponibilitat</param>
        /// <param name="descripcio">Descripció del recurs</param>
        /// <returns>Recurs creat</returns>
        public static Recurs CreateRecurs(String id_recurs, String id_seccio, Decimal preu, String nom_IVA, Int32 quantitat, Boolean disponibilitat_controlable, string descripcio)
        {
            Recurs recurs = new Recurs();
            recurs.Id_recurs = id_recurs;
            recurs.Id_seccio = id_seccio;
            recurs.Preu = preu;
            recurs.Nom_IVA = nom_IVA;
            recurs.Quantitat = quantitat;
            recurs.Descripcio = descripcio;
            recurs.Disponibilitat_controlable = disponibilitat_controlable;
            return recurs;
        }


        public override string ToString()
        {
            return this.Id_recurs;
        }

    }
}