﻿using System;
using System.ComponentModel;
using System.Collections.ObjectModel;
//using GestorXiquiparc;
using XiquiparcsReunits_Silverlight.Tools;
using XiquiparcsReunits_Silverlight.GestorXiquiparc;

namespace XiquiparcsReunits_Silverlight.Model
{
	public class TipusIVA: INotifyPropertyChanged
	{
		public String Nom_IVA{get;set;}

        private Decimal percentatge;
        public Decimal Percentatge 
        { 
            get 
            { 
                return percentatge; 
            }
            set 
            {
                percentatge = value; OnPropertyChanged("Percentatge"); 
            } 
        }

        private string descripcio;
        /// <summary>
        /// Cadena que descriu el tipus d'iva
        /// </summary>
        public string Descripcio { get { return descripcio; } set { descripcio = value; OnPropertyChanged("Descripcio");} }
        			
		public event PropertyChangedEventHandler PropertyChanged;

        private TipusIVA() { }

		public void OnPropertyChanged(string name){
			if (PropertyChanged !=null)
					PropertyChanged(this, new PropertyChangedEventArgs(name));
		}


        /// <summary>
        /// Funció que retorna una nova instància a partir de tots els paràmetres sense modificar la persistència
        /// </summary>
        /// <param name="nom_IVA">Nom identificador de l'IVA</param>
        /// <param name="percentatge">Percentatge que s'aplica</param>
        /// <param name="descripcio">Descripció del tipus d'IVA</param>
        /// <returns>Nou tipus d'IVA creat</returns>
	    public static TipusIVA CreateTipusIVA(String nom_IVA, Decimal percentatge, string descripcio)
        {
            TipusIVA tipusIVA = new TipusIVA();
            tipusIVA.Nom_IVA = nom_IVA;
            tipusIVA.Percentatge = percentatge;
            tipusIVA.Descripcio = descripcio;
            return tipusIVA;
        }

        /// <summary>
        /// Retorna el nom identificador del tipus d'IVA
        /// </summary>
        /// <returns>Cadena que representa l'objecte</returns>
		public override string ToString(){
			return this.Nom_IVA;
		}
	}
}