﻿using XiquiparcsReunits_Silverlight.ViewModels;
using Microsoft.Practices.Unity;
using System.Windows;
using Microsoft.Practices.Prism.Events;
using XiquiparcsReunits_Silverlight.Model;

namespace XiquiparcsReunits_Silverlight.Tools
{
	public class Locator
	{
			public IUnityContainer Container { get; set; }

            
           	public Locator(){

                Container = new UnityContainer();
                Container.RegisterType<PrincipalViewModel>(new ContainerControlledLifetimeManager());
                Container.RegisterType<GestionarUsuarisViewModel>(new ContainerControlledLifetimeManager());
                Container.RegisterType<GestionarEmpresaViewModel>(new ContainerControlledLifetimeManager());
                Container.RegisterType<GestionarRecursosViewModel>(new ContainerControlledLifetimeManager());
                Container.RegisterType<GestionarPaginesViewModel>(new ContainerControlledLifetimeManager());
                Container.RegisterType<GestionarFacturesViewModel>(new ContainerControlledLifetimeManager());
                Container.RegisterType<IEventAggregator, EventAggregator>(new ContainerControlledLifetimeManager());
             }
        
            public PrincipalViewModel PrincipalViewModel
            {

                get
                {
                    return Container.Resolve<PrincipalViewModel>();
                }
            }

            public GestionarEmpresaViewModel GestionarEmpresaViewModel
            {

                get
                {
                    return Container.Resolve<GestionarEmpresaViewModel>();
                }
            }

            public GestionarFacturesViewModel GestionarFacturesViewModel
            {
                get { return Container.Resolve<GestionarFacturesViewModel>(); }
            }
            public GestionarRecursosViewModel GestionarRecursosViewModel
            {
                get { return Container.Resolve<GestionarRecursosViewModel>(); }
            }

            public GestionarPaginesViewModel GestionarPaginesViewModel
            {
                get
                {
                    return Container.Resolve<GestionarPaginesViewModel>();
                }
            }

            public GestionarUsuarisViewModel GestionarUsuarisViewModel
            {
                get { return Container.Resolve<GestionarUsuarisViewModel>(); }
            }

			public IEventAggregator MessageBus{
				get { return Container.Resolve<IEventAggregator>();}
			}
    }
}
