﻿using System.Windows.Input;
using Microsoft.Practices.Prism.Commands;
using Microsoft.Practices.Prism.Events;
using XiquiparcsReunits_Silverlight.Tools;
using XiquiparcsReunits_Silverlight.Model;
using System;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.ServiceModel;
using System.Windows;

namespace XiquiparcsReunits_Silverlight.ViewModels
{
    public class GestionarEmpresaViewModel : ViewModel
    {
       
        public GestionarEmpresaViewModel(IEventAggregator messageBus)
        {

            this.messageBus = messageBus;  
            GestorXiquiparc.GestorXiquiparcClient client = InitClient();
            try{
            client.GetEmpresaCompleted += (sender, e) =>
            {
                EmpresaAModificar = Empresa.CreateEmpresa(e.Result.NIF, e.Result.nom_fiscal, e.Result.nom_comercial, e.Result.telefon1, e.Result.telefon2, e.Result.telefon3, e.Result.fax, e.Result.correu_electronic, e.Result.direccio_web, e.Result.direccio_empresa, e.Result.codpos_empresa, e.Result.poblacio, e.Result.provincia, e.Result.nom_gerent_empresa, e.Result.comentaris, e.Result.altra_info, e.Result.dades_mercantils, e.Result.estat);
            };
            client.GetEmpresaAsync();
           }
            catch (FaultException e)
            {
                MessageBox.Show(Strings.Actualizacio_fallida + e.Message);
            }
            catch (Exception e)
            {
                MessageBox.Show(Strings.Error_desconegut + e.Message);
            }        
        }


        //Propietat que registra les dades de la empresa que s'han de visualitzar
        #region ViewModelProperty: EmpresaAModificar
        private Empresa empresaAModificar;
        public Empresa EmpresaAModificar
        {
            get
            {
                
                return empresaAModificar;
            }
            set
            {
                empresaAModificar = value;
                OnPropertyChanged("EmpresaAModificar");
            }
        }
        #endregion
        
    }
}