﻿using System.ComponentModel;
using XiquiparcsReunits_Silverlight.Tools;
using Microsoft.Practices.Prism.Events;
using System;
using XiquiparcsReunits_Silverlight.Model;
using System.Windows.Input;
using System.Collections.ObjectModel;
using System.Windows;
using System.ServiceModel;
using System.ServiceModel.Channels;

namespace XiquiparcsReunits_Silverlight.ViewModels
{
    public abstract class ViewModel : INotifyPropertyChanged
    {
        private string[] provincies = { "Álava", "Albacete", "Alicante", "Almería", "Asturias", "Avila", "Badajoz", "Barcelona", "Burgos", "Cáceres", "Cádiz", "Cantabria", "Castellón", "Ceuta", "Ciudad Real", "Córdoba", "Cuenca", "Gerona", "Granada", "Guadalajara", "Guipúzcoa", "Huelva", "Huesca", "Islas Baleares", "Jaén", "La Coruña", "La Rioja", "Las Palmas", "León", "Lérida", "Lugo", "Madrid", "Málaga", "Melilla", "Murcia", "Navarra", "Orense", "Palencia", "Pontevedra", "S.C. de Tenerife", "Salamanca", "Segovia", "Sevilla", "Soria", "Tarragona", "Teruel", "Toledo", "Valencia", "Valladolid", "Vizcaya", "Zamora", "Zaragoza" };
        public ObservableCollection<String> Provincies { get { return new ObservableCollection<string>(provincies); } private set { } }
  
        private Uri selectedPage;

        public Uri SelectedPage
        {
            get { return selectedPage; }
            set { selectedPage = value; OnPropertyChanged("SelectedPage"); }
        }



        /// <summary>
        /// Propietats que afecten al comportament principal de la finestar contenidora      
        /// </summary>
        #region ViewModelProperty: ActiveWindow
        private Boolean _activeWindow = true;
        public Boolean ActiveWindow { get { return _activeWindow; } set { _activeWindow = value; OnPropertyChanged("ActiveWindow"); } }
        #endregion

        /// <summary>
        /// Funció que serà cridada en cada event de canvi de pàgina des d'altres ViewModel 
        /// </summary>
        /// <param name="obj"></param>
        public void ChangePage(Uri obj)
        {
            SelectedPage = obj;
        }
        
        public IEventAggregator messageBus{get;set;}

        public event PropertyChangedEventHandler PropertyChanged;
        public void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        /// <summary>
        /// Funció que prepara una connexió amb el servidor de client, preparant la capcelera SOAP amb el usuari i password
        /// del sistema
        /// </summary>
        /// <returns>Client creat</returns>
        protected GestorXiquiparc.GestorXiquiparcClient InitClient()
        {
            GestorXiquiparc.GestorXiquiparcClient client = new GestorXiquiparc.GestorXiquiparcClient();
            if (SingletonLoggedUser.Instance.LoggedUser != null)
            {
                OperationContextScope scope = new OperationContextScope((IContextChannel)client.InnerChannel);
                MessageHeaders messageHeadersElement = OperationContext.Current.OutgoingMessageHeaders;

                messageHeadersElement.Add(MessageHeader.CreateHeader("username", "", SingletonLoggedUser.Instance.LoggedUser.Id_usuari));
                messageHeadersElement.Add(MessageHeader.CreateHeader("password", "", SingletonLoggedUser.Instance.LoggedUser.Pwd));
            }
            return client;
        }

    }
}
